﻿<AML>
 <Item type="Method" id="90E48A909EC34F4EAF4A1E36431BB298" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			pop_invoice_call_pop_out
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	Get Company's Purchase Account and Service Account.
	Check choosing purchase order.If there is no choosing purchase order in Purchase Order,show alert.
	Clear previous relationships data initially in Stock Detail,Service Part Detail and Service Detail.
	Get Stock Detail,Service Detail and Service Part Detail according by choosing purchase order.
	And then set to pop_purchase_invoice_details,pop_invoice_service_details and pop_invoice_service_part.
	
Hooks:
	Type:	Form	:	pop_vendor_invoice
	Event:	sop_po_out ( onChange )

Revisions:
	Rev Date		Modified By			Description
	YYYY-MM-DD		$username$			Initial creation
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();
var _sum_tol = 0.0;
var erp_purchase_service_account = "";
var erp_purchase_account = "";

var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
var result = erp_company_setup.apply();
var result_count = result.getItemCount();
if (result_count > 0) {
    var setup = result.getItemByIndex(0);
    erp_purchase_service_account = setup.getProperty("erp_purchase_service_account", "");
    erp_purchase_account = setup.getProperty("erp_purchase_account", "");
}

var _gst_percent = top.aras.getItemProperty(document.item, 'pop_gst_percent');
var d_gst_percent = parseFloat(_gst_percent) / 100;

var thisItem = document.thisItem;

// Get selected SaleOrder Item 
var _sop_po_out_id = top.aras.getItemProperty(document.item, 'sop_po_out');
if (_sop_po_out_id === "") {
    return;
}

var _sop_po_out_item = myInnovator.getItemById("sop_po_out", _sop_po_out_id);
var _sop_po_out_item = myInnovator.newItem("sop_po_out", "get");
_sop_po_out_item.setProperty("id", _sop_po_out_id);
_sop_po_out_item = _sop_po_out_item.apply();

if (_sop_po_out_item.isError()) {
    return innovator.newError("Invalid Purchase Order No.");
}

var classification = _sop_po_out_item.getProperty("classification", "");
handleItemChange("classification", classification);

/** clear previous relationships data initially **/
if (classification === "SERVICE") {

    var d_gst_percent = 0;

    var fRelationships = thisItem.fetchRelationships("pop_invoice_service_details");
    var gRelationships = thisItem.getRelationships("pop_invoice_service_details");
    var itemCount = gRelationships.getItemCount();
    if (itemCount > 0) {
        for (var i = 0; i < itemCount; i++) {
            var item = gRelationships.getItemByIndex(i);
            thisItem.removeRelationship(item);
        }
    }

    var fRelationships = thisItem.fetchRelationships("pop_invoice_service_part");
    var gRelationships = thisItem.getRelationships("pop_invoice_service_part");
    var itemCount = gRelationships.getItemCount();
    if (itemCount > 0) {
        for (var i = 0; i < itemCount; i++) {
            var item = gRelationships.getItemByIndex(i);
            thisItem.removeRelationship(item);
        }
    }

    handleItemChange("acc_account", erp_purchase_service_account);
    handleItemChange("pop_gst_percent", d_gst_percent);
}

if (classification === "EQUIPMENT") {

    var fRelationships = thisItem.fetchRelationships("pop_purchase_invoice_details");
    var gRelationships = thisItem.getRelationships("pop_purchase_invoice_details");
    var itemCount = gRelationships.getItemCount();
    if (itemCount > 0) {
        for (var i = 0; i < itemCount; i++) {
            var item = gRelationships.getItemByIndex(i);
            thisItem.removeRelationship(item);
        }
    }

    handleItemChange("acc_account", erp_purchase_account);

}
/** clear previous relationships data initially **/



/** Start for Service  **/
var _service_details_qry = myInnovator.newItem("sop_po_service_details", "get");
_service_details_qry.setProperty("source_id", _sop_po_out_id);
var _service_details_items = _service_details_qry.apply();
var _count_ser = _service_details_items.getItemCount();


for (i = 0; i < _count_ser; i++) {
    var ser_details_item = _service_details_items.getItemByIndex(i);
    var stk_id = ser_details_item.getProperty("id", "");
    var stk_item = ser_details_item.getProperty("stk_item", "");
    var stk_qty = ser_details_item.getProperty("stk_qty", "");
    var stk_price = ser_details_item.getProperty("stk_price", "");
    var stk_total_amount = ser_details_item.getProperty("stk_total_amount", "");
    var related_id = ser_details_item.getProperty("related_id", "");

    var _ser_qty = parseFloat(stk_qty);
    var _ser_price = parseFloat(stk_price);
    var _ser_tol_amt = _ser_price * _ser_qty;

    var relationshipItem = myInnovator.newItem("pop_invoice_service_details", "add");
    relationshipItem.setProperty("related_id", related_id);
    relationshipItem.setProperty("stk_item", stk_item);
    relationshipItem.setProperty("stk_qty", stk_qty);
    relationshipItem.setProperty("stk_price", stk_price);
    relationshipItem.setProperty("stk_total_amount", _ser_tol_amt);
    relationshipItem.setProperty("source_id", document.thisItem.getProperty("id"));
    document.thisItem.addRelationship(relationshipItem);
    document.thisItem.setAttribute("isDirty", "1");
    _sum_tol += _ser_tol_amt;

}
/** End for Service**/


/** Start for Service (Part) **/
var _service_part_details_qry = myInnovator.newItem("sop_po_service_part_details", "get");
_service_part_details_qry.setProperty("source_id", _sop_po_out_id);
var _service_part_details_items = _service_part_details_qry.apply();
var _count_ser_part = _service_part_details_items.getItemCount();


for (i = 0; i < _count_ser_part; i++) {

    var ser_part_details_item = _service_part_details_items.getItemByIndex(i);
    var stk_id = ser_part_details_item.getProperty("id", "");
    var stk_item = ser_part_details_item.getProperty("stk_item", "");
    var stk_qty = ser_part_details_item.getProperty("stk_qty", "");
    var stk_price = ser_part_details_item.getProperty("stk_price", "");
    var stk_total_amount = ser_part_details_item.getProperty("stk_total_amount", "");
    var related_id = ser_part_details_item.getProperty("related_id", "");

    var _ser_part_qty = parseFloat(stk_qty);
    var _ser__part_price = parseFloat(stk_price);
    var _ser_part_tol_amt = _ser__part_price * _ser_part_qty;

    var relationshipItem = myInnovator.newItem("pop_invoice_service_part", "add");
    relationshipItem.setProperty("related_id", related_id);
    relationshipItem.setProperty("stk_item", stk_item);
    relationshipItem.setProperty("stk_qty", stk_qty);
    relationshipItem.setProperty("stk_price", stk_price);
    relationshipItem.setProperty("stk_total_amount", _ser_part_tol_amt);
    relationshipItem.setProperty("source_id", document.thisItem.getProperty("id"));
    document.thisItem.addRelationship(relationshipItem);
    document.thisItem.setAttribute("isDirty", "1");
    _sum_tol += _ser_part_tol_amt;

}
/** End for Service (Part) **/

/** Start for Equipment **/

var _sop_details_qry = myInnovator.newItem("sop_po_out_details", "get");
_sop_details_qry.setProperty("source_id", _sop_po_out_id);
var _sop_details_items = _sop_details_qry.apply();
var _count = _sop_details_items.getItemCount();

for (i = 0; i < _count; i++) {

    var sop_details_item = _sop_details_items.getItemByIndex(i);
    var stk_id = sop_details_item.getProperty("id", "");
    var stk_code = sop_details_item.getProperty("stk_code", "");
    var stk_description = sop_details_item.getProperty("stk_description", "");
    var stk_location = sop_details_item.getProperty("stk_location", "");
    var stk_category = sop_details_item.getProperty("stk_category", "");
    var stk_sub_category = sop_details_item.getProperty("stk_sub_category", "");
    var stk_uom = sop_details_item.getProperty("stk_uom", "");
    var stk_qty = sop_details_item.getProperty("stk_qty", "");
    var stk_base_qty = sop_details_item.getProperty("stk_base_qty", "");
    var stk_cost = sop_details_item.getProperty("stk_cost", "");
    var stk_base_cost = sop_details_item.getProperty("stk_base_cost", "");
    var stk_price = sop_details_item.getProperty("stk_price", "");
    var stk_total_amount = sop_details_item.getProperty("stk_total_amount", "");
    var stk_operator = sop_details_item.getProperty("stk_operator", "");
    var stk_ratio = sop_details_item.getProperty("stk_ratio", "");
    var stk_used_qty = sop_details_item.getProperty("stk_used_qty", "");

    var _con_qty = parseFloat(stk_qty);
    var _con_price = parseFloat(stk_price);
    var _con_used = parseFloat(stk_used_qty);
    var _diff = _con_qty - _con_used;
    var _new_tol_amt = _con_price * _diff;
    var relationshipItem = myInnovator.newItem("pop_purchase_invoice_details", "add");

    // If difference is greater than zero, add pop_purchase_invoice_details
    if (_diff > 0) {

        relationshipItem.setProperty("update_id", stk_id);

        var stock_item = myInnovator.newItem("stk_stock_setup", "get");
        stock_item.setProperty("id", stk_code);
        stock_item.setPropertyCondition("id", "eq");
        stock_item = stock_item.apply();
        var stock_item_count = stock_item.getItemCount();

        if (stock_item_count > 0) {
            relationshipItem.setPropertyItem("stk_code", stock_item);
            var stk_code = stock_item.getProperty("stk_code", "");
            relationshipItem.setProperty("stk_code_type", stk_code);
        }

        relationshipItem.setProperty("stk_description", stk_description);
        relationshipItem.setProperty("stk_location", stk_location);
        var l_stk_location = myInnovator.newItem("stk_location", "get");
        l_stk_location.setProperty("id", stk_location);
        l_stk_location.setPropertyCondition("source_id", "eq");
        l_stk_location = l_stk_location.apply();
        var l_stk_location_count = l_stk_location.getItemCount();
        if (l_stk_location_count > 0) {
            relationshipItem.setPropertyItem("stk_location", l_stk_location);
        }

        relationshipItem.setProperty("stk_category", stk_category);
        relationshipItem.setProperty("stk_sub_category", stk_sub_category);
        var l_stk_uom = myInnovator.newItem("stk_uom", "get");
        l_stk_uom.setProperty("id", stk_uom);
        l_stk_uom.setPropertyCondition("source_id", "eq");
        l_stk_uom = l_stk_uom.apply();
        var l_stk_uom_count = l_stk_uom.getItemCount();
        if (l_stk_uom_count > 0) {
            relationshipItem.setPropertyItem("stk_uom", l_stk_uom);
        }
        relationshipItem.setProperty("stk_qty", _diff);
        relationshipItem.setProperty("stk_base_qty", stk_base_qty);
        relationshipItem.setProperty("stk_cost", stk_cost);
        relationshipItem.setProperty("stk_base_cost", stk_base_cost);
        relationshipItem.setProperty("stk_price", stk_price);
        relationshipItem.setProperty("stk_total_amount", _new_tol_amt);
        relationshipItem.setProperty("stk_operator", stk_operator);
        relationshipItem.setProperty("stk_ratio", stk_ratio);
        relationshipItem.setProperty("source_id", document.thisItem.getProperty("id"));
        document.thisItem.addRelationship(relationshipItem);
        document.thisItem.setAttribute("isDirty", "1");
        _sum_tol += _new_tol_amt;
    }
}
/** End for Equipment **/

var _gst_amt = _sum_tol * d_gst_percent;
var _tol_amt = _gst_amt + _sum_tol;
handleItemChange("pop_gst_amount", _gst_amt.toFixed(2));
handleItemChange("pop_hide_sub_total", _sum_tol.toFixed(2)); //pop_hide_sub_total
handleItemChange("pop_sub_amount", _sum_tol.toFixed(2));
handleItemChange("pop_total_amount", _tol_amt.toFixed(2));


var pop_vendor_address = _sop_po_out_item.getProperty("pop_vendor_address", "");
handleItemChange("pop_address", pop_vendor_address);

/** show credit info for credit vendor **/
var vendor_id = _sop_po_out_item.getProperty("pop_vendor", "");

var item_vendor = myInnovator.newItem("vendor", "get");
item_vendor.setProperty("id", vendor_id);
item_vendor.setPropertyCondition("id", "eq");
var vendor_result = item_vendor.apply();
var vendor_count = vendor_result.getItemCount();

var iscredit = 0;
if (vendor_count > 0) {

    var pop_phone = vendor_result.getProperty("main_phone", "");
    handleItemChange("pop_phone", pop_phone);

    iscredit = vendor_result.getProperty("is_credit", "");
    var correction = getFieldByName("sop_iscredit");
    var correction_paymentterm = getFieldByName("sop_payment_term");
    var correction_duedate = getFieldByName("sop_due_date");
    handleItemChange("sop_iscredit", 0);
    if (iscredit === "1") {
        if (correction_paymentterm) {
            correction_paymentterm.disabled = false;
            correction_paymentterm.readOnly = false;
            correction_paymentterm.style.visibility = "visible";
            correction_paymentterm.style.display = "";
        }
        if (correction_duedate) {
            correction_duedate.disabled = false;
            correction_duedate.readOnly = false;
            correction_duedate.style.visibility = "visible";
            correction_duedate.style.display = "";
        }
    }
}
// end of show credit info for credit vendor


var pop_remarks = _sop_po_out_item.getProperty("pop_remarks", "");
handleItemChange("pop_invoice_remarks", pop_remarks);
handleItemChange("pop_vendor", vendor_id);

//update by yyk for currency

handleItemChange("pop_currency", _sop_po_out_item.getProperty("pop_currency", ""));
handleItemChange("pop_currency_rate", _sop_po_out_item.getProperty("pop_currency_rate", ""));
handleItemChange("pop_currency_operator", _sop_po_out_item.getProperty("pop_currency_operator", ""));
var currency_total_amt = 0.00;



var tabbar = parent.relationships.relTabbar;
var tabID = tabbar.GetTabId("Invoice Details");
parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);

parent.onRefresh();
return this;]]></method_code>
  <method_type>JavaScript</method_type>
  <name>pop_invoice_call_pop_out</name>
 </Item>
</AML>